import java.awt.*;
import java.util.*;
import java.awt.event.*;
import RC4;
import Base64;

class ImportExport extends Dialog implements ActionListener{
	private Button btnOK;
	private Button btnCancel;
	private Label lblConfirmation;
	private Label lblClef;
	private TextField tfConfirmation;
	private TextField tfClef;
	private TextArea taDatas;
	private porteClefs pc;
	private int type;

	public ImportExport(porteClefs pc, int type){
		super(new Frame(), "Importation / Exportation du porte-clefs", true);

		this.pc = pc;
		this.type = type;
		
		Panel panel = new Panel();
		panel.setLayout(null);

		taDatas = new TextArea("",10,10,java.awt.TextArea.SCROLLBARS_VERTICAL_ONLY );
		taDatas.setBounds(2,2,390,345);
		panel.add(taDatas);

		lblClef = new Label("Password");
		lblClef.setBounds(5,350,70,20);
		panel.add(lblClef);

		tfClef = new TextField(pc.masterKey);
		tfClef.setBounds(75,350,318,20);
		tfClef.setEchoChar('*');
		panel.add(tfClef);

		lblConfirmation = new Label("Confirmation");
		lblConfirmation.setBounds(5,370,70,20);
		panel.add(lblConfirmation);

		tfConfirmation = new TextField(pc.masterKey);
		tfConfirmation.setBounds(75,370,318,20);
		tfConfirmation.setEchoChar('*');
		panel.add(tfConfirmation);

		btnOK = new Button("OK");
		btnOK.setBounds(5,390,145,20);
		panel.add(btnOK);
		btnOK.addActionListener(this);

		btnCancel = new Button("Annuler");
		btnCancel.setBounds(150,390,145,20);
		panel.add(btnCancel);
		btnCancel.addActionListener(this);

		add(panel);
		setSize(400, 460);
		
		if (type==1){//Importation
			lblConfirmation.setVisible(false);
			tfConfirmation.setVisible(false);
		}
		else{//exportation
			taDatas.setEnabled(false);
			taDatas.setText("Veuillez entrer le mot de passe pour chiffrer le fichier contenant vos clefs secretes");
			btnOK.setLabel("Exporter");
		}
		show();
	}

	public void importationClefs(){
            byte[] key = (tfClef.getText()).getBytes();
            byte[] msg = Base64.decode((taDatas.getText()).getBytes());
		byte[] res = msg;
		RC4 algo = new RC4(key);
		
		algo.Initialize();
		algo.Update(msg, res);
		algo.Finalize();
		pc.masterKey = tfClef.getText();
		pc.KeyRing.clear();
		if(!(new String(res)).substring(res.length-32,res.length).equals(md5.hash((new String(res)).substring(0,res.length-32).getBytes()))){
			new Alert("Mot de passe non valide\nou porte clefs corrompu","Attention");
			return;
		}
		try {
		StringTokenizer st = new StringTokenizer((new String(res)).substring(0,res.length-32),"\t\n\r");
		while (st.hasMoreTokens()) {
			pc.KeyRing.put(st.nextToken(),st.nextToken());
		}
		}catch (NoSuchElementException e){
			new Alert("Ceci n'est pas un porte-clefs valide","Attention");
			return;
		}
		pc.choiceInit();
	}


	public void exportationClefs(){
		String clefTmp;
		String msgTmp;
		taDatas.setText("");
		msgTmp = "";
		for (Enumeration e = pc.KeyRing.keys() ; e.hasMoreElements() ;) {
			clefTmp = (String)e.nextElement();
			msgTmp=msgTmp + clefTmp+"\t"+ pc.KeyRing.get(clefTmp) +"\r\n";
		}
		msgTmp += md5.hash(msgTmp.getBytes());
            byte[] key = (tfClef.getText()).getBytes();
            byte[] msg = (msgTmp).getBytes();
		byte[] res = msg;
		RC4 algo = new RC4(key);
		
		algo.Initialize();
		algo.Update(msg, res);
		algo.Finalize();
		msg = Base64.encode(res);
		taDatas.setText(new String(msg));
		taDatas.setEnabled(true);
	}

	public void actionPerformed(ActionEvent actionevent){
		Object obj = actionevent.getSource();
		if(obj == btnCancel){
			hide();
		} else if(obj == btnOK){
			if(type==1){
				importationClefs();
				hide();
			}else{

				if ((tfClef.getText()).equals("")){
					taDatas.append("\r\nVeuillez entrer un mot de passe !!!");
				}
				else if( (tfConfirmation.getText()).equals(tfClef.getText()) ){
					pc.masterKey = tfClef.getText();
					exportationClefs();
				}
				else {
					taDatas.append("\r\nLes mots de passe entrs ne coincident pas !!!");
				}
			}
		}
	}

}
